;================================================
;	oCit@C BF
;	ver 1.01
;	for PC-G850 series
;	AASM 3.70
;	2006-10
;	by CHOI KYUN ikyuns@lily.freemail.ne.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	org	0100h



	;;;e`
	;L[
KEY_BREAK		equ	051h
KEY_S			equ	00ah
KEY_L			equ	029h
KEY_BS			equ	03ah
KEY_RET			equ	028h

SIZE_HEAD		equ	34+12	;t@Cwb_TCY



	;|C^
PTR_TEXT_START		equ	07973h	;W@eLXgGAJnAhX
PTR_TEXT_END		equ	07975h	;W@eLXgGAIAhX

PTR_BASIC_START		equ	079e1h	;W@BASICGAJnAhX
PTR_BASIC_END		equ	079e3h	;W@BASICGAIAhX

PTR_USER		equ	07ffeh	;W@}VGAIAhX
PTR_STACK_START		equ	079fch	;W@X^bNGAJnAhX

	;IOCSR[
SYS_PUT_CHAR		equ	0be62h		;1\
SYS_PUT_STRING		equ	0bff1h		;\
SYS_PUT_SAME_CHAR	equ	0bfeeh		;ꕶo

SYS_CLS			equ	0bfe2h		;ʃNA

SYS_SCROLL_UP		equ	0bfebh		;1sXN[Abv

SYS_BITMAP		equ	0bfd0h		;rbg}bv\

SYS_INKEY1		equ	0be53h		;L[1
SYS_INKEY2		equ	0bcfdh		;L[2

SYS_CONV_ASC		equ	0be56h		;L[R[hϊ

SYS_INPUT_HEX4		equ	0bd0fh		;416i

	;IOCS[N
WK_NEXT_POS		equ	07920h		;J[\XYW
WK_LAST_POS		equ	07922h		;J[\XYW


	;P[gAhXQƁ@AZu-TIvVt邱
rel_file_start		equ	_file_start-Start_SUB+07b00h
rel_file_end		equ	_file_end-Start_SUB+07b00h
rel_file_size		equ	_file_size-Start_SUB+07b00h
rel_work		equ	work-Start_SUB+07b00h


	;;;}N
	;AhX[h
ldx	macro	reg,adr
	ld	reg,adr-Start_SUB+07b00h
	endm

	;AhXR[
callx	macro	adr
	call	adr-Start_SUB+07b00h
	endm

	;AhXWv
jpx	macro	adr
	jp	adr-Start_SUB+07b00h
	endm



;==========================================================
;	vO{́iP[^uj
;==========================================================
Start:
	ld	hl,0e9e1h		;POP HL / JP (HL)
	ld	(08h),hl
	rst	08h			;LD HL,PC



;------------------------------------------------
;	C[`
;------------------------------------------------
Start_MAIN:
	ld	de,End_MAIN-Start_MAIN
	add	hl,de
	ld	de,07b00h
	ld	bc,End_SUB-Start_SUB
	ldir				;Tu[`]


;ʏ
	xor	a
	ld	b,24*6
	ld	d,a
	ld	e,a
	call	SYS_PUT_SAME_CHAR	;ꕶ\


;R}h\
	ld	de,0004h		;4,0
	ldx	hl,Mes_TITLE
	ld	b,15
	call	SYS_PUT_STRING		;< BINARY FILE >

	ld	de,0104h		;4,1
	ldx	hl,Mes_CMD
	ld	b,15
	call	SYS_PUT_STRING		;Save  Load


;R}h
	{
		call	SYS_INKEY2

		cp	KEY_BREAK
		ret	z			;[BREAK]ŏI
		cp	KEY_L
		jr	z,Load00		;[L]Ń[h
		cp	KEY_S
		jr	nz,continue		;[S]ŃZ[u
	}


;Z[u
Save:

;X^[gAhX
	ld	de,0200h		;0,2
	ldx	hl,Mes_START
	ld	b,6
	call	SYS_PUT_STRING		;START:

	ld	bc,4*256+17		;4́@0..9,A..F,BS
	ld	de,0206h
	ldx	hl,_file_start_info
	callx	Input

	ldx	hl,_file_start_info+2
	ldx	de,_file_start
	callx	AscToVal		;lɕϊ

;GhAhX
	ld	de,0300h		;0,3
	ldx	hl,Mes_END
	ld	b,6
	call	SYS_PUT_STRING		;END:

	ld	bc,4*256+17		;4́@0..9,A..F,BS
	ld	de,0306h
	ldx	hl,_file_end_info
	callx	Input

	ldx	hl,_file_end_info+2
	ldx	de,_file_end
	callx	AscToVal		;lɕϊ

;t@Cl[
	ld	de,0400h
	ldx	hl,Mes_NAME
	ld	b,6
	call	SYS_PUT_STRING		;NAME:

	ld	bc,8*256+37		;8́@0..9,A..Z,BS
	ld	de,0406h
	ldx	hl,_file_name
	callx	Input
	jr	_size


Load00:
	jr	Load01			;;;p


_size:
;TCY`FbN
	ld	de,(rel_file_start)
	ld	hl,(rel_file_end)
	or	a
	sbc	hl,de
	jr	c,_err

	inc	hl
	ld	(rel_work),hl		;t@C{̂̃TCY

	ld	de,SIZE_HEAD
	add	hl,de
	jr	c,_err
	ld	(rel_file_size),hl	;t@CTCY

;[`FbN
	ld	de,(PTR_BASIC_END)
	add	hl,de
	ld	de,(PTR_STACK_START)
	or	a
	sbc	hl,de
	jr	nc,_err

;vOt@C̈ɓ]
	ld	de,(PTR_TEXT_START)
	ld	hl,(PTR_BASIC_END)
	or	a
	sbc	hl,de
	ld	c,l
	ld	b,h
	inc	bc

	ld	de,(PTR_BASIC_END)
	ld	hl,(rel_file_size)
	push	hl

	add	hl,de
	ex	de,hl
	lddr				;t@CTCY󂯂
	jr	_send_file


Load01:
	jr	Load			;;;p


_send_file:
	pop	de
	ld	hl,(PTR_TEXT_END)
	add	hl,de
	ld	(PTR_TEXT_END),hl	;|C^ݒ

	ld	hl,(PTR_BASIC_START)
	add	hl,de
	ld	(PTR_BASIC_START),hl	;|C^ݒ

	ld	hl,(PTR_BASIC_END)
	add	hl,de
	ld	(PTR_BASIC_END),hl	;|C^ݒ

	ld	hl,(PTR_TEXT_START)
	push	hl
	add	hl,de
	ld	(PTR_TEXT_START),hl	;|C^ݒ

	pop	de
	ldx	hl,File_Format		;wb_]
	ld	bc,SIZE_HEAD
	ldir

	ld	bc,(rel_work)		;t@C{
	ld	hl,(rel_file_start)
	ldir

	ld	de,0500h
	push	de
	ldx	hl,Mes_S_OK		;SAVE OK
	ld	b,7
	call	SYS_PUT_STRING

	pop	de
	inc	d
	ld	(WK_NEXT_POS),de
	ld	(WK_LAST_POS),de
	ret


	;G[
_err:
	ld	de,0500h
	push	de
	ldx	hl,Mes_OVER
	ld	b,11
	call	SYS_PUT_STRING

	pop	de
	inc	d
	ld	(WK_NEXT_POS),de
	ld	(WK_LAST_POS),de
	ret



;[h
Load:
	ld	de,0200h		;2,0
	ldx	hl,Mes_NAME
	ld	b,6
	call	SYS_PUT_STRING		;NAME:

	ld	bc,8*256+37		;8́@0..9,A..Z,BS
	ld	de,0206h
	ldx	hl,_file_name
	callx	Input

;t@C
	ld	hl,(PTR_USER)
	ld	de,25			;vOGÃwb_
	add	hl,de

_find_top:
	ld	a,(hl)
	cp	0fbh
	jr	z,_find_file

	ld	de,0300h		;3,0
	push	de
	ldx	hl,Mes_NOFILE
	ld	b,9
	call	SYS_PUT_STRING		;NOT FIND

	pop	de
	ld	(WK_NEXT_POS),de
	ld	(WK_LAST_POS),de
	ret

_find_file
	push	hl
	push	hl
	inc	hl
	ldx	de,_file_name		;t@C̏ƍ
	ld	b,11
	{
		ld	a,(de)
		sub	(hl)
		jr	nz,break
		inc	hl
		inc	de
		djnz	continue
	}
	pop	hl
	ld	de,17
	add	hl,de
	ld	c,(hl)			;BC=t@CTCY
	inc	hl
	ld	b,(hl)

	pop	hl
	or	a
	jr	z,_found

	add	hl,bc			;̃t@C
	jr	_find_top

_found:
	ld	a,c
	sub	SIZE_HEAD
	ld	c,a
	ld	a,b
	sbc	a,0
	ld	b,a			;BC-wb_

	push	hl			;t@C擪
	push	hl
	ld	de,SIZE_HEAD
	add	hl,de

	pop	ix
	ld	e,(ix+34)		;[hԒn
	ld	d,(ix+35)

	ldir				;[h

_info:
	ld	de,0300h
	ldx	hl,Mes_L_OK
	ld	b,7
	call	SYS_PUT_STRING

	pop	hl
	ld	de,34+4			;[hԒn\
	add	hl,de
	push	hl
	ld	de,0406h		;6,4
	ld	b,4
	call	SYS_PUT_STRING

	ld	a,'-'
	ld	de,040ah		;10,4
	call	SYS_PUT_CHAR

	pop	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	de,040bh		;11,4
	ld	b,4
	call	SYS_PUT_STRING

	ld	de,0400h		;4,0
	push	de
	ldx	hl,Mes_INFO
	ld	b,6
	call	SYS_PUT_STRING		;INFO

	pop	de
	ld	(WK_NEXT_POS),de
	ld	(WK_LAST_POS),de
	ret
End_MAIN:



;==========================================================
;	Tu[`
;	07b00hȍ~ɔzu
;==========================================================
Start_SUB:
;------------------------------------------------
;	Cvbg\
;	in:	B	JEg
;		C	
;		HL	obt@
;		DE	XYW
;------------------------------------------------
Input:
	push	hl
	push	de
	push	bc

	ld	a,'_'
	call	SYS_PUT_CHAR

	call	SYS_INKEY2

	cp	KEY_BREAK		;[BREAK]ŏI
	jr	z,_return
	cp	KEY_RET			;[RET]œ͏I
	jr	z,_input_end

	call	SYS_CONV_ASC		;R[hϊ

	pop	bc
	push	bc
_check:
	ldx	hl,Str_data		;`FbN
	ld	b,0
	cpir

	pop	bc
	pop	de
	pop	hl
	jr	nz,Input
_bs:
	cp	08h			;BS
	jr	nz,_count

	ld	a,e			;X=6܂
	cp	6
	jr	z,Input

	ld	a,' '
	callx	Print
	dec	e

	dec	hl
	ld	(hl),020h

	inc	b
	jr	Input

_count:
	ld	ixl,a
	ld	a,b		;`FbN
	or	a
	jr	z,Input

	ld	a,ixl
	ld	(hl),a
	inc	hl
	dec	b

	callx	Print
	inc	e
	jr	Input


	;f
_return:
	pop	bc
	pop	de
	pop	hl

	pop	hl	;PC-2
	ret

	;͏I
_input_end:
	ld	a,' '
	call	SYS_PUT_CHAR

	pop	bc
	pop	de
	pop	hl
	ret


Str_data:
	db	'0123456789',08h,'ABCDEF'	;0..9,A..F,BS
	db	'GHIJKLMNOPQRSTUVWXYZ'



	;1\
Print:
	push	hl
	push	de
	push	bc
	call	SYS_PUT_CHAR		;1\
	pop	bc
	pop	de
	pop	hl
	ret

;------------------------------------------------
;	AXL[R[hAhXϊ
;	in:	(HL)	AXL[R[h
;	out:	(DE)	l
;------------------------------------------------
AscToVal:
	callx	AscToBin
	dec	hl
	dec	hl
	dec	hl
	dec	hl



;------------------------------------------------
;	AXL[R[hl
;------------------------------------------------
AscToBin:
	ld	a,(hl)
	inc	hl
	callx	AscToBin_sub
	rlca
	rlca
	rlca
	rlca
	ld	b,a

	ld	a,(hl)
	inc	hl
	callx	AscToBin_sub
	or	b
	ld	(de),a
	inc	de
	ret


AscToBin_sub:
	sub	030h
	cp	10
	ret	c
	sub	7
	ret



;==========================================================
;	f[^
;==========================================================
	;e탁bZ[W
Mes_TITLE:
	db	'< BINARY FILE >'
Mes_CMD:
	db	'Save       Load'

Mes_START:
	db	'START:'
Mes_END:
	db	'END  :'
Mes_NAME:
	db	'NAME :'

Mes_NOFILE:
	db	'NOT FOUND'
Mes_INFO:
	db	'INFO :'


Mes_S_OK:
	db	'SAVE OK'
Mes_L_OK:
	db	'LOAD OK'

Mes_OVER:
	db	'MEMORY OVER'



	;t@CtH[}bg wb_34+12Byte
File_Format:
	db	0fbh						;ATTR
_file_name:
	db	'A',020h,020h,020h,020h,020h,020h,020h		;t@Cl[iftHgA.BINj
_file_ext:
	db	'BIN'						;gqiftHgBINj
	db	5 dup (0)					;
_file_size:
	db	0,0						;t@CTCY
	db	15 dup (0)					;
_file_start:
	db	0,0						;[hԒn
_file_end:
	db	0,0						;IԒn
_file_start_info:
	db	'0100'						;CtHp
_file_end_info:
	db	'0000'						;CtHp


;==========================================================
;	[N
;==========================================================
Work:
	ds	2

End_SUB:



	end
	